﻿function msgBoxAJAX(url) {
	this.AjaxFailedAlert = "Your browser does not support the enhanced functionality of this website, and therefore you will have an experience that differs from the intended one.\n";
	this.requestUrl = url;
	this.method = "GET";
	this.URLString = "";
	this.encodeURIString = true;
	this.execute = false;

	this.onLoading = function() {};
	this.onLoaded = function() {};
	this.onInteractive = function() {};
	this.onCompletion = function() {};

	this.createAJAX = function() {
		try	{
			this.xmlhttp = new XMLHttpRequest();
		}
		catch (e) {
			try {
				this.xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
			}
			catch (e) {
				this.xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
			}
		}
		if (!this.xmlhttp) {
			this.failed = true;
		}
	};

	this.setVar = function(name, value) {
		if (this.URLString.length < 3) {
			this.URLString = name + "=" + value;
		} else {
			this.URLString += "&" + name + "=" + value;
		}
	};

	this.encVar = function(name, value) {
		var varString = encodeURIComponent(name) + "=" + encodeURIComponent(value);
		return varString;
	};

	this.encodeURLString = function(string) {
		var varArray = string.split('&');
		var urlVars;
		for (var i = 0; i < varArray.length; i++) {
			urlVars = varArray[i].split('=');
			if (urlVars[0].indexOf('amp;') != -1) {
				urlVars[0] = urlVars[0].substring(4);
			}
			varArray[i] = this.encVar(urlVars[0], urlVars[1]);
		}
		return varArray.join('&');
	};

	this.runResponse = function() {
		eval(this.response);
	};

	this.runAJAX = function(urlstring) {
		this.responseStatus = new Array(2);
		if (this.failed && this.AjaxFailedAlert) {
			alert(this.AjaxFailedAlert);
		} else {
			if (urlstring) {
				if (this.URLString.length) {
					this.URLString = this.URLString + "&" + urlstring;
				} else {
					this.URLString = urlstring;
				}
			}
			if (this.encodeURIString) {
				var timeval = new Date().getTime();
				this.URLString = this.encodeURLString(this.URLString);
				this.setVar("rndval", timeval);
			}
			if (this.element) {
				this.elementObj = document.getElementById(this.element);
			}
			if (this.xmlhttp) {
				var selfRef = this;
				if (this.method == null) {
					this.method = "GET";
				}
				if (this.method == "GET") {
					var totalurlstring = this.requestUrl + "?" + this.URLString;
					this.xmlhttp.open("GET", totalurlstring, true);
				} else {
					this.xmlhttp.open("POST", this.requestUrl, true);
				}
				if (this.method == "POST") {
					try {
						this.xmlhttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded;charset=UTF-8');
					} catch(e) {}
				}

				this.xmlhttp.send(this.URLString);
				this.xmlhttp.onreadystatechange = function() {
					switch (selfRef.xmlhttp.readyState) {
					case 1:
						selfRef.onLoading();
						break;
					case 2:
						selfRef.onLoaded();
						break;
					case 3:
						selfRef.onInteractive();
						break;
					case 4:
						selfRef.response = selfRef.xmlhttp.responseText;
						selfRef.responseXML = selfRef.xmlhttp.responseXML;
						selfRef.responseStatus[0] = selfRef.xmlhttp.status;
						selfRef.responseStatus[1] = selfRef.xmlhttp.statusText;
						selfRef.onCompletion();
						if (selfRef.execute) {
							selfRef.runResponse();
						}
						if (selfRef.elementObj) {
							var elemNodeName = selfRef.elementObj.nodeName;
							elemNodeName.toLowerCase();
							if (elemNodeName == "input" || elemNodeName == "select" || elemNodeName == "option" || elemNodeName == "textarea") {
								selfRef.elementObj.value = selfRef.response;
							} else {
								selfRef.elementObj.innerHTML = selfRef.response;
							}
						}
						selfRef.URLString = "";
						break;
					default:
						break;
					}
				};
			}
		}
	};
	this.createAJAX();
}

function _ge(id) {return document.getElementById(id);}

function MessageBox(thisObject, msgContainer, maxMessages, autoHideTime /* in milli Seconds*/) {
	// Public Variables
	this.msgContainer = msgContainer;
	this.maxMessages = maxMessages;
	this.autoHideTime = autoHideTime;
	this.msgTypes = {DEFAULT: -1, INFO: '#FFFF80', ALERT: '#FF7E00', ERROR: '#FF0000'};

	// Private Variables
	var self = thisObject;
	var msgBoxArray = [];
	var ajaxObjects = [];
	var msgQueue = [];
	var currMsgIndex = -1;
	var containerObj = _ge(this.msgContainer);

	// Public Methods
	this.activateMsgBox = function(msgHeader, url, minutesBeforeReload, autoHideTime, msgType) {
		currMsgIndex = msgBoxArray.length;
		var intervalObj = false;

		if (minutesBeforeReload && minutesBeforeReload > 0) {
			intervalObj = setInterval( self + ".reloadMsgBox(" + currMsgIndex + ",'" + self + "')", (minutesBeforeReload * 1000 * 60));
		}
		msgBoxArray[currMsgIndex] = {};
		msgBoxArray[currMsgIndex].msgHeader = msgHeader;
		msgBoxArray[currMsgIndex].Url = url;
		msgBoxArray[currMsgIndex].autoHideTime = autoHideTime;
		msgBoxArray[currMsgIndex].intervalObj = intervalObj;
		msgBoxArray[currMsgIndex].msgType = msgType;

		this.reloadMsgBox(currMsgIndex, self);
		return currMsgIndex;
	};

	this.createMsgBox = function(msgHeader, msgContent, msgIndex, autoHideTime, msgType) {
		while (msgQueue.length >= this.maxMessages) {
			var index = msgQueue.shift();
			this.closeMsgBoxWith(index);
		}

		if (msgIndex != null) {
			currMsgIndex = msgIndex;
		}
		else {
			if (!autoHideTime) {
				autoHideTime = this.autoHideTime;
			}
			currMsgIndex = msgBoxArray.length;
			msgBoxArray[currMsgIndex] = {};
			msgBoxArray[currMsgIndex].msgHeader = msgHeader;
			msgBoxArray[currMsgIndex].autoHideTime = autoHideTime;
			msgBoxArray[currMsgIndex].msgType = msgType;
		}

		var messageDiv = document.createElement('DIV');
		messageDiv.className = 'MessageBox';
		messageDiv.id = 'MessageBox' + currMsgIndex;

		var headerDiv = document.createElement('DIV');
		headerDiv.className = 'messageBoxHeader';
		headerDiv.id = 'messageBoxHeader' + currMsgIndex;

		var headerSpan = document.createElement('SPAN');
		headerSpan.id = 'messageBoxHeaderText' + currMsgIndex;
		headerSpan.innerHTML = msgHeader;
		headerDiv.appendChild(headerSpan);
		messageDiv.appendChild(headerDiv);

		var closeLink = document.createElement('A');
		closeLink.id = 'messageBoxCloseLink' + currMsgIndex;
		closeLink.className = 'messageBoxCloseLink';
		closeLink.innerHTML = 'X';
		closeLink.onmouseover = this.handleMsgBoxMouseOver;
		closeLink.onmouseout = this.handleMsgBoxMouseOut;
		closeLink.onclick = this.closeMsgBox;
		headerDiv.appendChild(closeLink);

		var contentDiv = document.createElement('DIV');
		contentDiv.className = 'MessageBoxContent';
		contentDiv.id = 'MessageBoxContent' + currMsgIndex;
		if (msgBoxArray[currMsgIndex].msgType != this.msgTypes.DEFAULT) {
			contentDiv.style.backgroundColor = msgBoxArray[currMsgIndex].msgType;
		}
		contentDiv.innerHTML = msgContent;
		messageDiv.appendChild(contentDiv);

		var msgs = containerObj.getElementsByTagName('DIV');
		if (msgs.length > 0) {
			containerObj.insertBefore(messageDiv, msgs[0]);
		}
		else {
			containerObj.appendChild(messageDiv);
		}

		msgQueue[msgQueue.length] = currMsgIndex;
		messageDiv.style.width = (containerObj.offsetWidth-5) + "px";
		this.animateMsgBox(0, currMsgIndex, 1);

		return currMsgIndex;
	};

	this.handleMsgBoxMouseOver = function() {
		this.className = 'messageBoxCloseLinkOver';
	};

	this.handleMsgBoxMouseOut = function() {
		this.className = 'messageBoxCloseLink';
	};

	this.closeMsgBox = function() {
		var msgIndex = this.id.replace(/[^0-9]/g, '');
		eval(self + ".closeMsgBoxWith(" + msgIndex + ")");
	};

	this.animateMsgBox = function(param, msgIndex, action) {
		var messageDiv = _ge("MessageBox" + msgIndex);
		if(!messageDiv) {
			return;
		}
		if (action == 1) {
			messageDiv.style.filter = 'alpha(opacity='+ param +')';
			messageDiv.style.opacity = (param/100);
			if (param < 99) {
				param += 10;
				setTimeout(self+".animateMsgBox("+param+","+ msgIndex+", 1)", 100);
			}
			else {
					if(msgBoxArray[currMsgIndex].autoHideTime && msgBoxArray[currMsgIndex].autoHideTime > 0) {
						setTimeout(self + ".closeMsgBoxWith(" + msgIndex + ")", msgBoxArray[currMsgIndex].autoHideTime);
					}
			}
		}
		else if (action == 2) {
			if (param == "height") {
				param = messageDiv.offsetHeight;
				messageDiv.style.overflow = "hidden";
				messageDiv.style.filter = 'alpha(opacity=30)';
				messageDiv.style.opacity = 0.3;
			}
			if (param > 0) {
				param -= 3;
				if(param <= 0) {
					containerObj.removeChild(messageDiv);
					return;
				}
				messageDiv.style.height = param + "px";
				setTimeout(self+".animateMsgBox("+param+","+ msgIndex+", 2)", 1);
			}
			else {
				containerObj.removeChild(messageDiv);
			}
		}
	};

	this.closeMsgBoxWith = function(msgIndex) {
		this.animateMsgBox("height", msgIndex, 2);
		this.clearMsgQueue(msgIndex);
	};

	this.clearMsgQueue = function(msgIndex) {
		var i = 0;
		while (i < msgQueue.length) {
			if (msgQueue[i] != msgIndex) {
				i++;
			}
			else {
				break;
			}
		}
		if (i < msgQueue.length) {
			msgQueue.splice(i, 1);
		}
	};

	this.reloadMsgBox = function(msgIndex, referral) {
		var ajaxIndex = ajaxObjects.length;
		ajaxObjects[ajaxIndex] = new msgBoxAJAX();
		ajaxObjects[ajaxIndex].requestUrl = msgBoxArray[msgIndex].Url;
		ajaxObjects[ajaxIndex].onCompletion = function() {
			eval(referral + ".showMsgBox("+ ajaxIndex + "," + msgIndex + ")");
		};
		ajaxObjects[ajaxIndex].runAJAX();
	};

	this.showMsgBox = function(ajaxIndex, msgIndex) {
		var msgContent = ajaxObjects[ajaxIndex].response;
		if (msgContent && msgContent.length > 0) {
			this.clearMsgQueue(msgIndex);
			var messageDiv = _ge("MessageBox" + msgIndex);
			if (messageDiv) {
				containerObj.removeChild(messageDiv);
			}
			this.createMsgBox(msgBoxArray[msgIndex].msgHeader, msgContent, msgIndex, msgBoxArray[msgIndex].autoHideTime);
		}
		delete(ajaxObjects[ajaxIndex]);
		ajaxObjects[ajaxIndex] = false;
	};
}
